
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Grant_tranchesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grant_tranches = await db.grant_tranches.create(
            {
                id: data.id || undefined,
        
        tranche_number: data.tranche_number
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        planned_disbursement_at: data.planned_disbursement_at
        ||
        null
            ,
            
        disbursed_at: data.disbursed_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        conditions: data.conditions
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await grant_tranches.setApplication( data.application || null, {
            transaction,
        });
        
        await grant_tranches.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return grant_tranches;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const grant_tranchesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                tranche_number: item.tranche_number
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                planned_disbursement_at: item.planned_disbursement_at
            ||
            null
            ,
            
                disbursed_at: item.disbursed_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                conditions: item.conditions
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const grant_tranches = await db.grant_tranches.bulkCreate(grant_tranchesData, { transaction });

        // For each item created, replace relation files
        

        return grant_tranches;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const grant_tranches = await db.grant_tranches.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.tranche_number !== undefined) updatePayload.tranche_number = data.tranche_number;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.planned_disbursement_at !== undefined) updatePayload.planned_disbursement_at = data.planned_disbursement_at;
        
        
        if (data.disbursed_at !== undefined) updatePayload.disbursed_at = data.disbursed_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.conditions !== undefined) updatePayload.conditions = data.conditions;
        
        
        updatePayload.updatedById = currentUser.id;

        await grant_tranches.update(updatePayload, {transaction});

        
        
        if (data.application !== undefined) {
            await grant_tranches.setApplication(
              
              data.application,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await grant_tranches.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return grant_tranches;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grant_tranches = await db.grant_tranches.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of grant_tranches) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of grant_tranches) {
                await record.destroy({transaction});
            }
        });


        return grant_tranches;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const grant_tranches = await db.grant_tranches.findByPk(id, options);

        await grant_tranches.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await grant_tranches.destroy({
            transaction
        });

        return grant_tranches;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const grant_tranches = await db.grant_tranches.findOne(
            { where },
            { transaction },
        );

        if (!grant_tranches) {
            return grant_tranches;
        }

        const output = grant_tranches.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.application = await grant_tranches.getApplication({
            transaction
        });
        
        
        output.organizations = await grant_tranches.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.grant_applications,
        as: 'application',
        
        where: filter.application ? {
          [Op.or]: [
            { id: { [Op.in]: filter.application.split('|').map(term => Utils.uuid(term)) } },
            {
              application_reference: {
                [Op.or]: filter.application.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.conditions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'grant_tranches',
                        'conditions',
                        filter.conditions,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            planned_disbursement_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    disbursed_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.tranche_numberRange) {
                const [start, end] = filter.tranche_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tranche_number: {
                    ...where.tranche_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tranche_number: {
                    ...where.tranche_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.planned_disbursement_atRange) {
                const [start, end] = filter.planned_disbursement_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    planned_disbursement_at: {
                    ...where.planned_disbursement_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    planned_disbursement_at: {
                    ...where.planned_disbursement_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.disbursed_atRange) {
                const [start, end] = filter.disbursed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    disbursed_at: {
                    ...where.disbursed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    disbursed_at: {
                    ...where.disbursed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.grant_tranches.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'grant_tranches',
                        'conditions',
                        query,
                    ),
                ],
            };
        }

        const records = await db.grant_tranches.findAll({
            attributes: [ 'id', 'conditions' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['conditions', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.conditions,
        }));
    }

    
};

